package com.contextspace.acl.model;

import java.io.Serializable;

import javax.jdo.annotations.Index;
import javax.jdo.annotations.Indices;
import javax.persistence.Basic;
import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.FetchType;
import javax.persistence.OneToOne;

@Entity
@Indices({
	@Index(members={"oidId", "type"}),
    @Index(members={"parentAcl"})
})

public class TestEntity extends TestIdHolder {
	private static final long serialVersionUID = 6249921651146397564L;
    
    @OneToOne(cascade=CascadeType.REFRESH, fetch=FetchType.EAGER)
    private TestEntity parentAcl;
    @Basic
    private boolean entriesInheriting = true;
    
    private long oidId;
    
    private String type;
    
    public TestEntity(String type, long id,TestEntity parentAcl, boolean entriesInheriting) {
    		this.oidId = id;
    		this.type = type;
            this.parentAcl = (TestEntity)parentAcl; // may be null
            this.entriesInheriting = entriesInheriting;
    }
    /**
     * Private no-argument constructor for use by reflection-based persistence
     * tools along with field-level access.
     */
    @SuppressWarnings("unused")
    private TestEntity() {}
    
	public void setEntriesInheriting(boolean entriesInheriting) {
        this.entriesInheriting = entriesInheriting;
	}
	
	public Serializable getId() {
		return super.getLongId();
	}
	
	public void setParentAcl(TestEntity parentAcl) {
        this.parentAcl = parentAcl;
	}

	
	public TestEntity getParentAcl() {
		return parentAcl;
	}
	
	public boolean isEntriesInheriting() {
		return entriesInheriting;
	}

	public long getOidId() {
		return oidId;
	}

	public void setOidId(long oidId) {
		this.oidId = oidId;
	}

	public String getType() {
		return type;
	}

	public void setType(String type) {
		this.type = type;
	}
}
